import { defineComponent, h, onUnmounted, provide, inject, ref, onMounted } from 'vue';
import { columnProps } from './column';
import { watchColumn, assemColumn, destroyColumn } from '../../table/src/util';
import Cell from '../../table/src/cell';
export default defineComponent({
    name: 'VxeColgroup',
    props: columnProps,
    setup(props, { slots }) {
        const refElem = ref();
        const $xeTable = inject('$xeTable', {});
        const parentColgroup = inject('$xeColgroup', null);
        const column = Cell.createColumn($xeTable, props);
        const columnSlots = {};
        if (slots.header) {
            columnSlots.header = slots.header;
        }
        column.slots = columnSlots;
        column.children = [];
        watchColumn($xeTable, props, column);
        onMounted(() => {
            assemColumn($xeTable, refElem.value, column, parentColgroup);
        });
        onUnmounted(() => {
            destroyColumn($xeTable, column);
        });
        const renderVN = () => {
            return h('div', {
                ref: refElem
            }, slots.default ? slots.default() : []);
        };
        const $xeColgroup = { column };
        provide('$xeColgroup', $xeColgroup);
        provide('$xeGrid', null);
        return renderVN;
    }
});
