"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _vue = require("vue");
var _column = require("./column");
var _util = require("../../table/src/util");
var _cell = _interopRequireDefault(require("../../table/src/cell"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
var _default = exports.default = (0, _vue.defineComponent)({
  name: 'VxeColgroup',
  props: _column.columnProps,
  setup(props, {
    slots
  }) {
    const refElem = (0, _vue.ref)();
    const $xeTable = (0, _vue.inject)('$xeTable', {});
    const parentColgroup = (0, _vue.inject)('$xeColgroup', null);
    const column = _cell.default.createColumn($xeTable, props);
    const columnSlots = {};
    if (slots.header) {
      columnSlots.header = slots.header;
    }
    column.slots = columnSlots;
    column.children = [];
    (0, _util.watchColumn)($xeTable, props, column);
    (0, _vue.onMounted)(() => {
      (0, _util.assemColumn)($xeTable, refElem.value, column, parentColgroup);
    });
    (0, _vue.onUnmounted)(() => {
      (0, _util.destroyColumn)($xeTable, column);
    });
    const renderVN = () => {
      return (0, _vue.h)('div', {
        ref: refElem
      }, slots.default ? slots.default() : []);
    };
    const $xeColgroup = {
      column
    };
    (0, _vue.provide)('$xeColgroup', $xeColgroup);
    (0, _vue.provide)('$xeGrid', null);
    return renderVN;
  }
});